--FILMAGE RenderEffect Script.
--Beta 0.52s - 3/17/99
--For more info on the FilmAge script (MAX 2.5 version as Utility)
--visit http://gfxcentral.com/bobo/ipas/filmage/


plugin RenderEffect FilmAge 
    name:"FilmAge"
    classID:#(0x47937a1c, 0x62587a3c) 
(

--INIT arrays to hold the linear scratch parameters
local crack_l_array_pos = #()
local crack_l_array_width = #()
local crack_l_array_cover = #()
local crack_l_color = #()
local crack_l_array_dur = #()
local crack_l_count = -1
--(1) Linear scratches need to change over multiple frames.
--Since there is still no way to get the currently rendered frame number passed over
--by the Renderer, the Script may not reinitialize the arrays if the crack_l_count 
--is higher than -1.

rollout info_roll "Render Info"
(
label aboutfa06 "No Frames Rendered Yet." 
)

rollout lines_roll "Linear Scratches"
(
checkbutton crack_lines_yes "Apply Linear Scratches" width:300 checked:true align:#center highlightcolor:([200,255,200] as color)
tooltip:"Vertical linear scratches caused by dust particles. (fast)"
--Green highlight color denotes fast effects.

label cl01 "Scratches Count" align:#left across:3 
spinner crack_lines_mincount "Min." range:[0,500,10] type:#integer fieldwidth:50 align:#center
spinner crack_lines_maxcount "Max." range:[1,500,20] type:#integer fieldwidth:50 align:#right 

label cl02 "Scratch Life (frames)" align:#left across:3
spinner crack_lines_mindur "Min." range:[1,1000,5] type:#integer fieldwidth:50 align:#center 
spinner crack_lines_maxdur "Max." range:[1,1000,24] type:#integer fieldwidth:50 align:#right

label cl03 "Scratch Width" align:#left across:3
spinner crack_lines_minwidth "Min." range:[1,20,1] type:#integer align:#center fieldwidth:50
spinner crack_lines_maxwidth "Max." range:[1,20,5] type:#integer align:#right fieldwidth:50

label cl04 "Scratch Coverage %" align:#left across:3
spinner crack_lines_mincover "Min." range:[0,99,10] type:#integer align:#center fieldwidth:50
spinner crack_lines_maxcover "Max." range:[1,100,70] type:#integer align:#right fieldwidth:50

colorpicker line_color_min "Color From:" color:[255,200,255] align:#left across:2 fieldwidth:100
colorpicker line_color_max "To:" color:[200,255,255] align:#right fieldwidth:100

on crack_lines_mincount changed value do
(
crack_l_count = -1
--When the number of scratches has been changed,
--the script has to reset the Linear Scratches arrays.
--Setting the count to -1 tells the script to reinitialize.
--See (1).
)
on crack_lines_maxcount changed value do
(
crack_l_count = -1
)
)

rollout curls_roll "Curly Scratches"
(
checkbutton crack_curls_yes "Apply Curly Scratches" width:300 checked:true align:#center enabled:true highlightcolor:([200,255,200] as color)
tooltip:"Hair-like curly scratches (fast)"

label cl01 "Curls Count" align:#left across:3
spinner curl_mincount "Min." range:[0,24,0] type:#integer align:#center fieldwidth:50
spinner curl_maxcount "Max." range:[0,24,3] type:#integer align:#right fieldwidth:50

label cl02 "Curls Length" align:#left across:3
spinner curl_minlen "Min." range:[3,1000,30] type:#integer align:#center fieldwidth:50
spinner curl_maxlen "Max." range:[3,1000,50] type:#integer align:#right fieldwidth:50

colorpicker curls_color "Curl Color  " color:[10,10,10] align:#left across:2 fieldwidth:100
spinner curly_factor "Curl Factor" range:[1,20,3] type:#integer align:#right fieldwidth:50
)


rollout dust_roll "Dust Particles"
(
checkbutton dust_yes "Apply Dust Particles" width:300 checked:true align:#center highlightcolor:([200,255,200] as color)
tooltip:"Dust pixels are mixed with the original pixels (fast)"

label dust01 "Particle Count" align:#left across:3
spinner dust_mincount "Min." range:[0,1000,100] type:#integer align:#center fieldwidth:50
spinner dust_maxcount "Max." range:[1,1000,200] type:#integer align:#right fieldwidth:50

label dust02 "Particle Height" align:#left across:3
spinner dust_minsize "Min." range:[1,100,1] type:#integer align:#center fieldwidth:50
spinner dust_maxsize "Max." range:[1,100,4] type:#integer align:#right fieldwidth:50

label dust04 "Particle Width" align:#left across:3
spinner dust_minwid "Min." range:[1,100,1] type:#integer align:#center fieldwidth:50
spinner dust_maxwid "Max." range:[1,100,2] type:#integer align:#right fieldwidth:50

label dust03 "Coverage %" align:#left across:3
spinner dust_mincover "Min." range:[0,99,40] type:#integer align:#center fieldwidth:50
spinner dust_maxcover "Max." range:[1,100,70] type:#integer align:#right fieldwidth:50

colorpicker dust_color_min "Color From:" color:[60,60,60] align:#left across:2 fieldwidth:100
colorpicker dust_color_max "To:" color:[100,100,10] align:#right fieldwidth:100
)


rollout color_roll "Color Changes"
(
group "Color Loss"
(
checkbutton desat_yes "Use Color Loss" width:296 checked:true align:#center highlightcolor:([255,200,200] as color)
tooltip:"Frame-based desaturation."

spinner color_loss "Color Loss %" range:[0,100,85] fieldwidth:50 align:#right
checkbutton negative_yes "Negative" width:296 checked:false align:#center highlightcolor:([255,200,200] as color)
tooltip:"Frame-based color inversion."

checkbutton color_shift_yes "Use Color Tinting" width:296 checked:true align:#center enabled:true highlightcolor:([255,200,200] as color)
tooltip:"Mix original colors with a user-defined Tinting Color."

colorpicker shift_color "Tinting Color" color:[128,90,60] align:#left  fieldwidth:100 across:2
spinner shift_percent "Tinting %" range:[0,100,25] type:#float align:#right fieldwidth:50 
label cl01 ""
)

on desat_yes changed state do
(
if desat_yes.checked then
	(
	negative_yes.enabled = true
	color_shift_yes.enabled = true
	--The other two Color Changes functions are used 
	--ONLY if the Color Loss is active
	)
	else
	(
	negative_yes.enabled = false
	color_shift_yes.enabled = false
	)
)



group "Granularity"
(
checkbutton gran_yes "Use Granularity" width:296 checked:false align:#center highlightcolor:([255,200,200] as color)
tooltip:"Pixel-level version of the Color Loss effect."

label granlab "Strength %" across:3 align:#left
spinner gran_min "Min." range:[0,100,0] type:#integer align:#center  fieldwidth:50
spinner gran_max "Max." range:[1,100,20] type:#integer align:#right  fieldwidth:50

checkbutton pict_loss_yes "Image Loss" width:296 checked:false align:#center highlightcolor:([255,200,200] as color)
tooltip:"Pixel-level version of the Image Tinting. Uses the same Strength as Granularity."

colorpicker pict_loss_color "Replace Color" color:[190,170,250] align:#left fieldwidth:100
)

group "Color Dimming"
(
checkbutton color_dimming_yes "Use Color Dimming" width:296 checked:false align:#center highlightcolor:([255,200,200] as color)
tooltip:"Frame-based color changes caused by aging of the film."

label dimmlab "Dimming %" across:3 align:#left
spinner dimming_min "Min." range:[0,100,0] type:#integer align:#center  fieldwidth:50
spinner dimming_max "Max." range:[1,100,30] type:#integer align:#right  fieldwidth:50
)

)

rollout frame_roll "Frame Effects"
(
checkbutton drop_frames_yes "Drop Frames" width:300 checked:true align:#center highlightcolor:([200,255,200] as color)
tooltip:"Replace a percentage of frames with empty frames"

colorpicker drop_frames_color "Empty Frm. Color" color:[190,170,250] align:#left fieldwidth:100 across:2

spinner drop_percent "Drop %" range:[0,100,0.1] type:#float fieldwidth:50 align:#right

checkbutton frame_shake_yes "Frame Desynchronization" width:300 checked:true align:#center highlightcolor:([200,255,200] as color)
tooltip:"A random frame up/down movement caused by old movie projector mechanics"

label fram01 "Desynchronization" across:3 align:#left
spinner shake_y_min "Min." range:[0,100,1] type:#integer align:#center fieldwidth:50
spinner shake_y_max "Max." range:[1,100,5] type:#integer align:#right fieldwidth:50
)

rollout about_filmage "Presets / About FilmAge"
(
label aboutfa01 "FilmAge Reffect Script"
label aboutfa02 "Beta 0.52s - 3/17/99"
label aboutfa03 "by Borislav Petrov"
label aboutfa05 "http://gfxcentral.com/bobo/" 

button save_set "SAVE PRESETS" width:140 align:#left across:2
button load_set "LOAD PRESETS" width:140 align:#right

on save_set pressed do
(
file_name = getSaveFileName caption:"SAVE FilmAge Presets (.FAP) File" types:"FilmAge Preset(.FAP)|*.fap|All files (*.*)|*.*|"
		if file_name != undefined then
		(
		ln = findstring file_name "."
		if ln == undefined then (file_name = file_name + ".fap" )
		--Check for dot character. If there is none, add correct extension.
		--Note that you can enter ANY extension and load it later using the All Files type
		
		file = createFile(file_name)
		if file != undefined then
		(
		(format "%\n" "FilmAge 05s" to:file)
		--Version string. Currently, the version number is not used.
		--It might be needed in the future to check for correct format
		--in case later versions use a different format.
		
		(format "%\n" (lines_roll.crack_lines_yes.state as string) to:file)
		(format "%\n" (lines_roll.crack_lines_mincount.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_maxcount.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_mindur.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_maxdur.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_minwidth.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_maxwidth.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_mincover.value as string) to:file)
		(format "%\n" (lines_roll.crack_lines_maxcover.value as string) to:file)
		(format "%\n" (lines_roll.line_color_min.color.r as string) to:file)
		(format "%\n" (lines_roll.line_color_min.color.g as string) to:file)
		(format "%\n" (lines_roll.line_color_min.color.b as string) to:file)		
		(format "%\n" (lines_roll.line_color_max.color.r as string) to:file)
		(format "%\n" (lines_roll.line_color_max.color.g as string) to:file)
		(format "%\n" (lines_roll.line_color_max.color.b as string) to:file)		
	
		(format "%\n" (curls_roll.crack_curls_yes.state as string) to:file)	
		(format "%\n" (curls_roll.curl_mincount.value as string) to:file)
		(format "%\n" (curls_roll.curl_maxcount.value as string) to:file)
		(format "%\n" (curls_roll.curl_minlen.value as string) to:file)
		(format "%\n" (curls_roll.curl_maxlen.value as string) to:file)
		(format "%\n" (curls_roll.curls_color.color.r as string) to:file)
		(format "%\n" (curls_roll.curls_color.color.g as string) to:file)
		(format "%\n" (curls_roll.curls_color.color.b as string) to:file)
		(format "%\n" (curls_roll.curly_factor.value as string) to:file)

		(format "%\n" (dust_roll.dust_yes.state as string) to:file)
		(format "%\n" (dust_roll.dust_mincount.value as string) to:file)
		(format "%\n" (dust_roll.dust_maxcount.value as string) to:file)
		(format "%\n" (dust_roll.dust_minsize.value as string) to:file)
		(format "%\n" (dust_roll.dust_maxsize.value as string) to:file)
		(format "%\n" (dust_roll.dust_minwid.value as string) to:file)
		(format "%\n" (dust_roll.dust_maxwid.value as string) to:file)
		(format "%\n" (dust_roll.dust_mincover.value as string) to:file)
		(format "%\n" (dust_roll.dust_maxcover.value as string) to:file)
		(format "%\n" (dust_roll.dust_color_min.color.r as string) to:file)
		(format "%\n" (dust_roll.dust_color_min.color.g as string) to:file)
		(format "%\n" (dust_roll.dust_color_min.color.b as string) to:file)		
		(format "%\n" (dust_roll.dust_color_max.color.r as string) to:file)
		(format "%\n" (dust_roll.dust_color_max.color.g as string) to:file)
		(format "%\n" (dust_roll.dust_color_max.color.b as string) to:file)

		(format "%\n" (color_roll.desat_yes.state as string) to:file)
		(format "%\n" (color_roll.color_loss.value as string) to:file)	
		(format "%\n" (color_roll.negative_yes.state as string) to:file)
		(format "%\n" (color_roll.color_shift_yes.state as string) to:file)
		(format "%\n" (color_roll.shift_color.color.r as string) to:file)
		(format "%\n" (color_roll.shift_color.color.g as string) to:file)
		(format "%\n" (color_roll.shift_color.color.b as string) to:file)
		(format "%\n" (color_roll.shift_percent.value as string) to:file)	
		
		(format "%\n" (color_roll.gran_yes.state as string) to:file)
		(format "%\n" (color_roll.gran_min.value as string) to:file)
		(format "%\n" (color_roll.gran_max.value as string) to:file)
	
		(format "%\n" (color_roll.pict_loss_yes.state as string) to:file)
		(format "%\n" (color_roll.pict_loss_color.color.r as string) to:file)
		(format "%\n" (color_roll.pict_loss_color.color.g as string) to:file)
		(format "%\n" (color_roll.pict_loss_color.color.b as string) to:file)

		(format "%\n" (color_roll.color_dimming_yes.state as string) to:file)
		(format "%\n" (color_roll.dimming_min.value as string) to:file)
		(format "%\n" (color_roll.dimming_max.value as string) to:file)

		(format "%\n" (frame_roll.drop_frames_yes.state as string) to:file)
		(format "%\n" (frame_roll.drop_frames_color.color.r as string) to:file)
		(format "%\n" (frame_roll.drop_frames_color.color.g as string) to:file)
		(format "%\n" (frame_roll.drop_frames_color.color.b as string) to:file)
		(format "%\n" (frame_roll.drop_percent.value as string) to:file)	
		(format "%\n" (frame_roll.frame_shake_yes.state as string) to:file)
		(format "%\n" (frame_roll.shake_y_min.value as string) to:file)
		(format "%\n" (frame_roll.shake_y_max.value as string) to:file)
		
		)	
		close file
		)	
)

on load_set pressed do
(

	file_name = getOpenFileName caption:"LOAD FilmAge Presets (.FAP) File" types:"FilmAge Preset(.FAP)|*.fap|All files (*.*)|*.*|"

		if file_name != undefined then
		(
		ln = findstring file_name "."
		if ln == undefined then (file_name = file_name + ".fap" )
		--In case the user has entered a name without extension 
		--(basically by typing a name instead of clicking at the file)
		--the default extension is added automatically.
		
		file = openFile(file_name)
		if file != undefined then
		(	
		str = readline file
		vers = findstring str "FilmAge"
		--Read first line and check for the version string.
		--Currently, only the program name is checked.
		
		if vers == undefined then
		(
		MessageBox "FILMAGE ERROR:\nThe selected file is not a valid \n FilmAge Presets file!"
		--Error message in case the file was there but wasn't written by FilmAge
		
		)
		else
		(

-- read linear scratches 

		r = readline file
		if r == "true" then lines_roll.crack_lines_yes.state = true else lines_roll.crack_lines_yes.state = false
		r = readline file
		lines_roll.crack_lines_mincount.value = r as float
		r = readline file
		lines_roll.crack_lines_maxcount.value = r as float
		r = readline file
		lines_roll.crack_lines_mindur.value = r as float
		r = readline file		
		lines_roll.crack_lines_maxdur.value = r as float
		r = readline file
		lines_roll.crack_lines_minwidth.value = r as float
		r = readline file
		lines_roll.crack_lines_maxwidth.value = r as float
		r = readline file
		lines_roll.crack_lines_mincover.value = r as float
		r = readline file
		lines_roll.crack_lines_maxcover.value = r as float
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color
		lines_roll.line_color_min.color = tcol
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color
		lines_roll.line_color_max.color= tcol
		
--read curls settings

		r = readline file
		if r == "true" then curls_roll.crack_curls_yes.state = true else curls_roll.crack_curls_yes.state = false
		r = readline file
		curls_roll.curl_mincount.value = r as float
		r = readline file		
		curls_roll.curl_maxcount.value = r as float
		r = readline file		
		curls_roll.curl_minlen.value = r as float
		r = readline file		
		curls_roll.curl_maxlen.value = r as float
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color
		curls_roll.curls_color.color = tcol
		r = readline file		
		curls_roll.curly_factor.value = r as float

--read dust settings

		r = readline file
		if r == "true" then dust_roll.dust_yes.state  = true else dust_roll.dust_yes.state  = false
		r = readline file		
		dust_roll.dust_mincount.value = r as float
		r = readline file		
		dust_roll.dust_maxcount.value  = r as float
		r = readline file		
		dust_roll.dust_minsize.value  = r as float
		r = readline file		
		dust_roll.dust_maxsize.value  = r as float
		r = readline file		
		dust_roll.dust_minwid.value  = r as float
		r = readline file		
		dust_roll.dust_maxwid.value  = r as float
		r = readline file		
		dust_roll.dust_mincover.value  = r as float
		r = readline file		
		dust_roll.dust_maxcover.value  = r as float
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color
		dust_roll.dust_color_min.color = tcol
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color
		dust_roll.dust_color_max.color = tcol


--read color settings

		r = readline file
		if r == "true" then color_roll.desat_yes.state  = true else color_roll.desat_yes.state  = false
		r = readline file
		color_roll.color_loss.value = r as float
		r = readline file
		if r == "true" then color_roll.negative_yes.state  = true else color_roll.negative_yes.state  = false
		r = readline file		
		if r == "true" then color_roll.color_shift_yes.state = true else color_roll.color_shift_yes.state = false
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color	
		color_roll.shift_color.color = tcol		
		r = readline file		
		color_roll.shift_percent.value = r as float	
		r = readline file	
		if r == "true" then 	color_roll.gran_yes.state= true else 	color_roll.gran_yes.state = false
		r = readline file	
		color_roll.gran_min.value = r as float
		r = readline file		
		color_roll.gran_max.value  = r as float
		r = readline file	
		if r == "true" then color_roll.pict_loss_yes.state = true else color_roll.pict_loss_yes.state = false
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color	
		color_roll.pict_loss_color.color = tcol
		r = readline file
		if r == "true" then color_roll.color_dimming_yes.state = true else color_roll.color_dimming_yes.state = false
		r = readline file
		color_roll.dimming_min.value  = r as float
		r = readline file
		color_roll.dimming_max.value = r as float
		r = readline file
		if r == "true" then frame_roll.drop_frames_yes.state = true else frame_roll.drop_frames_yes.state = false
		r = readline file
		g = readline file
		b = readline file
		tcol = [r as float,g as float ,b as float] as color	
		frame_roll.drop_frames_color.color  = tcol
		r = readline file
		frame_roll.drop_percent.value = r as float
		r = readline file
		if r == "true" then frame_roll.frame_shake_yes.state = true else 	frame_roll.frame_shake_yes.state = false
		r = readline file
		frame_roll.shake_y_min.value = r as float
		r = readline file
		frame_roll.shake_y_max.value = r as float
		)
		)	
		)
)
)


on apply nbmp do
(

progress_display_bitmap = bitmap 300 10
pixel_array = #()
for i = 1 to 300 do
(
append pixel_array ([191,191,191] as color)
)
for i = 0 to 9 do
(
setpixels progress_display_bitmap [0,i] pixel_array
)

stamp_start = timestamp ()
--Get a time stamp to calculate rendering time for a single frame

bmp_w = nbmp.width
bmp_h = nbmp.height
--Get size of the image passed over by the renderer.

tbmp = bitmap bmp_w bmp_h 
--Create a Temp file with the same size.

if crack_l_count > lines_roll.crack_lines_maxcount.value or crack_l_count == -1 then
--Start initialization of the Linear Crack arrays in case they need to be updated. See (1)
	(
	crack_l_count = random lines_roll.crack_lines_mincount.value lines_roll.crack_lines_maxcount.value 
	--Generate a random number of cracks between the min and max values
	
	for i = 1 to crack_l_count do
	(
	--For every crack, generate a random property value:

	crack_l_array_dur[i] = random lines_roll.crack_lines_mindur.value lines_roll.crack_lines_maxdur.value
	--Generate random Life value of the crack line
	
	crack_l_array_pos[i] = random 1 (RenderWidth-lines_roll.crack_lines_maxwidth.value - 1 )
	--Generate random initial position of the line
	
	crack_l_array_width[i] = random  lines_roll.crack_lines_minwidth.value lines_roll.crack_lines_maxwidth.value  
	--Generate rendom width
	
	crack_l_array_cover[i] = random  lines_roll.crack_lines_mincover.value lines_roll.crack_lines_maxcover.value
	--Generate random coverage percentage
	
	crack_l_color[i] = random (lines_roll.line_color_min.color) (lines_roll.line_color_max.color)
	--Generate random color
	)
	)

pixel_array = #()
--temp. array to hold a whole pixel row

	dimming_percent = (random color_roll.dimming_min.value color_roll.dimming_max.value	) as float
	dimming_percent = (100 - dimming_percent)/100 as float
	--Calculate a random dimming percentage value. Each frame will have a different
	--dimming value, causing a typical old movie flashing 
	
	color_shift_percent = ((100-color_roll.shift_percent.value)/100) as float
	color_shift_percent2 = (color_roll.shift_percent.value/100) as float
	--(2) Calculate two tinting values - the one for multiplying the original color,
	--the other for multiplying the tinting color. 


if frame_roll.drop_frames_yes.checked then
	(
	rnd = random 0 10000
	--Generate a random value between 0 and 10000
	
	if rnd <= (frame_roll.drop_percent.value*100.0) then 
		(
		--Compare the value with the user percentage * 100
		--In case the value is lower or equal, drop the frame. 
		--If the user has entered 100, any value will be 100*100
		--and the statement will be always true -> drop EVERY frame
		
		fill_array = #()
		--temp array for filling a row with user color
		
		fill_color = frame_roll.drop_frames_color.color
		--put user color for the dropped frame into a color variable 
		--to put into array
		
		for i = 1 to bmp_w do append fill_array fill_color
		--append the color into every pixel of the row
		
		for i = 1 to bmp_h do setpixels nbmp [0,i-1] fill_array
		--write the color array into every row of the image 
		)
	)


if frame_roll.frame_shake_yes.checked then
	(
	shake_y = random frame_roll.shake_y_min.value frame_roll.shake_y_max.value
	--Generate a custom number of rows to move the frame

	if (random 1 3) == 2 then shake_y = -shake_y
	--Generate a random value and change the direction depending on result
	
	)
	else
	(
	shake_y = 0
	--No movement if the checkbutton is unchecked
	)
	

--START OF THE PIXEL-BASED AND ROW-BASED EFFECTS -------------------------------------------

for h = 0 to bmp_h-1 do
(
--Loop through all rows in image. Note that bitmap indices are 0-based


old_array = #()
old_array = getpixels nbmp [0,h] bmp_w
--Get the original pixels row into an array

color_part = ((100.0 - color_roll.color_loss.value) / 100.0)
--Calculate the color percentage for the color loss function

for w = 1 to bmp_w do
	(
--Loop through the pixels in the row (arrays are 1-based)

if color_roll.negative_yes.checked then 
	(
	old_array[w] = ([255,255,255] as color ) - old_array[w]	
	--Invert the original color value in case the Negative checkbutton is active
	)
		
if color_roll.desat_yes.checked then
(
	bw = ((old_array[w].r + old_array[w].g + old_array[w].b ) / 3) as integer
	--Calculate the monochrome value
	
	bw_part = (bw * (color_roll.color_loss.value / 100) as float) as integer
	--Calculate the monochrome part in the image

	old_array[w].r =   (bw_part + (old_array[w].r * color_part)) as integer
	old_array[w].g =  (bw_part + (old_array[w].g * color_part)) as integer
	old_array[w].b =  (bw_part  + (old_array[w].b * color_part)) as integer
	--Set the old color as mix of monochrome part and color part 
	
	
	if color_roll.color_shift_yes.checked then
	(
	old_array[w].r =  ((old_array[w].r * color_shift_percent) + (color_roll.shift_color.color.r * color_shift_percent2 )) as integer
	old_array[w].g =  ((old_array[w].g * color_shift_percent) + (color_roll.shift_color.color.g * color_shift_percent2 )) as integer
	old_array[w].b =  ((old_array[w].b * color_shift_percent) + (color_roll.shift_color.color.b * color_shift_percent2 )) as integer
	--Set the old color as mix of the original color and the tinting color, both multiplied by the tinting percentages calculated in (2)
	)
	
)--end desat

	gran_perc = (random color_roll.gran_min.value color_roll.gran_max.value) as float
	--Generate a random granularity percentage value for the current pixel

	if color_roll.gran_yes.checked then 
	(	
	old_array[w].r =  (old_array[w].r * (100.0-gran_perc)/100.0) as integer
	old_array[w].g =  (old_array[w].g * (100.0-gran_perc)/100.0) as integer
	old_array[w].b =  (old_array[w].b * (100.0-gran_perc)/100.0) as integer
	--Set the original pixel color as a percentage of itself (reduce the color by the percentage)
	)
	
	if color_roll.pict_loss_yes.checked then
	(
	old_array[w].r =  (old_array[w].r + ((((gran_perc)/100.0)as float) * color_roll.pict_loss_color.color.r) as float) as integer
	old_array[w].g =  (old_array[w].g + ((((gran_perc)/100.0)as float) * color_roll.pict_loss_color.color.g) as float) as integer
	old_array[w].b =  (old_array[w].b + ((((gran_perc)/100.0)as float) * color_roll.pict_loss_color.color.b) as float) as integer
	--Add the same percentage of the Replace Color to the pixel value
	)
	
	if color_roll.color_dimming_yes.checked then
	(
	old_array[w].r =  (old_array[w].r * dimming_percent) as integer
	old_array[w].g =  (old_array[w].g * dimming_percent) as integer
	old_array[w].b =  (old_array[w].b * dimming_percent) as integer
	--Reduce the color value by the frame-based dimming percentage
	)	
	
	
	if old_array[w].r < 0 then old_array[w].r = 0
	if old_array[w].g < 0 then old_array[w].g = 0
	if old_array[w].b < 0 then old_array[w].b = 0

	if old_array[w].r > 255 then old_array[w].r = 255
	if old_array[w].g > 255 then old_array[w].g = 255
	if old_array[w].b > 255 then old_array[w].b = 255	
	--Check for over/underflow to avoid color artefacts.
	
	)-- end w loop

	
	
if shake_y+h <= 0 then 
	(
	setpixels tbmp [0,shake_y+h+bmp_h] old_array
	--If the new row vertical index is negative, add bitmap height to put the row at the lower part of the image
	--Use the temp image file created at the start
	)
	else
	(
	if shake_y+h > bmp_h then 
		(
		setpixels tbmp [0,shake_y+h-bmp_h] old_array
		--If the new row vertical index is higher than the last row, 
		--reduce with bitmap height to put the row at the upper part of the image
		--Use the temp image file created at the start
		)
		else
		(
		setpixels tbmp [0,shake_y+h] old_array
		--If the row is inside of the image, just put it there
		--Use the temp image file created at the start
		)
	)	

)--end h loop
--Here ends the pixel-based part of the effects. Any speed improvements
--should be attempted in these loops.

copy tbmp nbmp
--copy the temp file into the original image



--DRAWING THE LINEAR CRACKS------------------------------------------------------------------------------

if lines_roll.crack_lines_yes.checked then 
(
for i = 1 to crack_l_count do
--Loop through the array of linear cracks
(
if crack_l_array_dur[i] == 0 then
	(
	--In case the Life of the line has expired, it should be born again: Reinitialize variables
	crack_l_array_dur[i] = random lines_roll.crack_lines_mindur.value lines_roll.crack_lines_maxdur.value
	crack_l_array_pos[i] = random 1 (bmp_w-lines_roll.crack_lines_maxwidth.value - 1 )
	crack_l_array_width[i] = random  lines_roll.crack_lines_minwidth.value lines_roll.crack_lines_maxwidth.value  
	crack_l_array_cover[i] = random  lines_roll.crack_lines_mincover.value lines_roll.crack_lines_maxcover.value
	crack_l_color[i] = random (lines_roll.line_color_min.color) (lines_roll.line_color_max.color)
	)
	else
	(
	crack_l_array_dur[i] = crack_l_array_dur[i] - 1
	--Reduce life value of the linear crack
	
	if crack_l_array_pos[i] > 0 and crack_l_array_dur[i] > 5 then 
		(
		crack_l_array_pos[i] = crack_l_array_pos[i] - 1
		--As long as the horizontal position is positive and the life is longer than 5 frames,
		--move the line to the left
		)
	if crack_l_array_pos[i] < (bmp_w-lines_roll.crack_lines_maxwidth.value )  and crack_l_array_dur[i] < 5 then 
		(
		crack_l_array_pos[i] = crack_l_array_pos[i] + 1
		--As long as the horizontal position is bellow the right edge of the image and 
		--remaining life is shorter than 5 frames,
		--move the line to the right
		)
	)
)

pixel_array = #()
old_array = #()

for w = 0 to bmp_h-1 do
(
for j = 1 to crack_l_count do
	(
	pixel_array = #()
	old_array = getpixels nbmp [crack_l_array_pos[j],w] crack_l_array_width[j]
	--Get old pixels where the crack is going to appear
	
	for i = 1 to crack_l_array_width[j] do
	(
	pixel_array[i]=[0,0,0] as color
	pixel_array[i].r = ((old_array[i].r * (100.0-crack_l_array_cover[j])/100.0) + ((crack_l_color[j].r) * (crack_l_array_cover[j])/100.0)) as integer
	pixel_array[i].g = ((old_array[i].g * (100.0-crack_l_array_cover[j])/100.0) + ((crack_l_color[j].g) * (crack_l_array_cover[j])/100.0)) as integer
	pixel_array[i].b = ((old_array[i].b * (100.0-crack_l_array_cover[j])/100.0) + ((crack_l_color[j].b) * (crack_l_array_cover[j])/100.0)) as integer
	--Set colors for the current crack by mixing the original pixel color with the crack color
	)
	
	setpixels nbmp [crack_l_array_pos[j],w] pixel_array
	--Put back the pixels into the image
	)
)--end w loop
)--end if lines


if dust_roll.dust_yes.checked then 
(
dust_count = random dust_roll.dust_mincount.value dust_roll.dust_maxcount.value 
--Generate a random number of dust particles

for w = 1 to dust_count do
(
pixel_array = #()
dust_dy = random dust_roll.dust_minsize.value dust_roll.dust_maxsize.value
dust_dx = random dust_roll.dust_minwid.value dust_roll.dust_maxwid.value
--Generate random height and width values for the current particle

dust_x = random 1 (bmp_w-dust_dx-1)
dust_y = random 1 (bmp_h-dust_dy-1)
--Generate random X and Y position values

dust_cover = (random dust_roll.dust_mincover.value dust_roll.dust_maxcover.value ) as float
dust_color = random (dust_roll.dust_color_min.color) (dust_roll.dust_color_max.color)
--Generate random coverage and color values

old_array = getpixels nbmp [dust_x,dust_y] dust_dx
--Get old pixels only from the current particle area

for i = 1 to dust_dx do
(
pixel_array[i] = [0,0,0] as color
pixel_array[i].r = ((old_array[i].r * ((100-dust_cover)/100)as float) + ((dust_color.r) * (((dust_cover)/100) as float) ) )as integer
pixel_array[i].g = ((old_array[i].g * ((100-dust_cover)/100)as float) + ((dust_color.g) * (((dust_cover)/100) as float) ) )as integer
pixel_array[i].b = ((old_array[i].b * ((100-dust_cover)/100)as float) + ((dust_color.b) * (((dust_cover)/100) as float) ) )as integer
--Set the pixel colors as a mix of the original color and the dust particle color (using coverage percentage)
)

for i = 1 to dust_dy do
(
setpixels nbmp [dust_x,dust_y+i-1] pixel_array
--Put back the pixels into the particle area
)
)

)--end if dust


if curls_roll.crack_curls_yes.checked then
	(
	pixel_array = #()
	pixel_array[1] = curls_roll.curls_color.color
	--Set an array with just one color value
	
	curl_count = random curls_roll.curl_mincount.value curls_roll.curl_maxcount.value 
	--Generate a random number of hair cracks

	for j = 1 to curl_count do
	(	
	curl_x = random 0 bmp_w
	curl_y = random 0 bmp_h
	--Generate "pencil" start position
	curl_dx = 1
	curl_dy = 1
	--Set starting direction delta values
	curl_len = random curls_roll.curl_minlen.value curls_roll.curl_maxlen.value 
	--Generate a random length value
	
	for i = 1 to curl_len do
	(
	rnd = random 1 (curls_roll.curly_factor.value + 6)
	--Generate a random value to decide which way to go.
	--The higher the user variable (Curl Factor),
	--the lower the chance for a direction change
	
	case rnd of
	(
	1: (curl_dx = 1)
	2: (curl_dx = -1)
	3: (curl_dx = 0)
	4: (curl_dy = 1)
	5: (curl_dy = -1)
	6: (curl_dy = 0)	
	--Change the direction delta value based on the value drawn.
	)-- end case
	
	curl_x = curl_x + curl_dx
	curl_y = curl_y + curl_dy
	--Move the "pencil" using the delta values
	
	setpixels nbmp [curl_x,curl_y] pixel_array
	--Draw a pixel at the current "pencil" position
	
	)-- end i loop
	)-- end j loop
)--end if curls

stamp_end = timestamp ()
--End of the processing, get a time stamp again.

stamp_time = ((stamp_end - stamp_start)as float)/1000
--Calculate the time elapsed in milliseconds , divide by 1000 to get Seconds

info_roll.aboutfa06.text = ("Last Frame Processing Time: " + stamp_time as string + " sec.")
--Put the time value into the label

)--end on apply 

)--end plugin